<?php

namespace App\Model;

/**
 * Description of DateTime
 *
 * @author Monsterboy
 */
class DateTime extends \Nette\Object
{
    /**
     * Simple function to calculate the difference between two datetime values, returning the result in seconds.
     *
     * @param $dt1
     * @param $dt2
     * @return bool|string
     */
    public function timeDiff($dt1,$dt2)
    {
        $y1 = substr($dt1,0,4);
        $m1 = substr($dt1,5,2);
        $d1 = substr($dt1,8,2);
        $h1 = substr($dt1,11,2);
        $i1 = substr($dt1,14,2);
        $s1 = substr($dt1,17,2);

        $y2 = substr($dt2,0,4);
        $m2 = substr($dt2,5,2);
        $d2 = substr($dt2,8,2);
        $h2 = substr($dt2,11,2);
        $i2 = substr($dt2,14,2);
        $s2 = substr($dt2,17,2);

        $r1=date('U',mktime($h1,$i1,$s1,$m1,$d1,$y1));
        $r2=date('U',mktime($h2,$i2,$s2,$m2,$d2,$y2));
        return ($r1-$r2);

    }

    /**
     * Convert seconds to minutes
     *
     * @param $seconds
     * @return float
     */
    public function secondsToMinutes($seconds)
    {
        $minutes = $seconds/60;
        return $minutes;
    }

    /**
     * Convert minutes to hours
     *
     * @param $minutes
     * @return float
     */
    public function minutesToHours($minutes)
    {
        $hours = $minutes/60;
        return $hours;
    }

    /**
     * Convert hours to days
     *
     * @param $hours
     * @return float
     */
    public function hoursToDays($hours)
    {
        $days = $hours/60;
        return $days;
    }

    /**
     * Convert time in seconds to convenient form
     *
     * @param $seconds
     * @return string
     */
    public function getTimeInConvenientUnits($seconds)
    {
        if ($seconds < 60)
        {
            return $seconds." s";
        }
        elseif ($seconds >= 60 && $seconds < 3600)
        {
            $output = $this->secondsToMinutes($seconds);
            return round($output)." min.";
        }
        elseif ($seconds >= 3600 && $seconds < 86400)
        {
            $output = $this->minutesToHours($this->secondsToMinutes($seconds));
            return round($output)." hod.";
        }
        elseif ($seconds >= 86400 && $seconds < 2592000)
        {
            $output = $this->hoursToDays($this->minutesToHours($this->secondsToMinutes($seconds)));
            if (round($output) == 1)
            {
                return round($output)." dnem";
            }
            else
            {
                return round($output)." dny";
            }
        }
        else
        {
            return 'déle než měsícem';
        }
    }

}
