<?php

namespace App\Model;

use Nette,
    Nette\Security\Passwords;

/**
 * Manage database table housekeeper
 *
 * @author Monsterboy
 */
class Favorite extends Base
{
    protected $tableName = 'favorite';
    public $database;
    protected $dateTime;
    protected $encodeString;

    function __construct(Nette\Database\Context $database, DateTime $dateTime, EncodingString $enc)
    {
        $this->database = $database;
        $this->dateTime = $dateTime;
        $this->encodeString = $enc;
    }

    /**
     * Ukládá oblíbené inzeráty
     * 
     * @param array $values Hodnoty z formuláře
     * @return bool
     */
    public function addFavorite($userId, $adId) {

        if ($this->isSetFavorite($userId, $adId) > 0)
        {
            return false;
        }

        $valuesDB = array();
        $valuesDB['ad_id'] = $adId;
        $valuesDB['user_id'] = $userId;
        $valuesDB['created'] = date('Y-m-d H:i:s');

        $insertedId = $this->insert($valuesDB);
        return $insertedId;
    }

    public function isSetFavorite($userId, $adId)
    {
        $by = array("ad_id"=>$adId, "user_id"=>$userId);
        return $this->countBy($by);
    }

    /**
     * @param $adId
     * @return int
     */
    public function remove($adId)
    {
        return $this->delete(array("ad_id" => $adId));
    }

    /**
     * @param $userId
     * @return array
     */
    public function getAll($userId)
    {
        $results = array();
        $rows = $this->findBy(array("user_id" => $userId));
        while ($row = $rows->fetch())
        {
            $results[] = $row['ad_id'];
        }
        return $results;
    }
}
