<?php

namespace App\Model;

use Nette,
    Nette\Security\Passwords;

/**
 * Select list of ads according the filters
 *
 * @author Monsterboy
 */
class Listing extends Base
{
    protected $tableName = 'ad';
    public $database;
    protected $dateTime;
    protected $fav;
    protected $seen;
    protected $ad;

    public $make;
    public $model;
    public $category;
    public $subcategory;
    public $priceFrom;
    public $priceTo;
    public $condition;
    public $area_level_1;
    public $user;
    public $seller;
    public $orderBy;
    public $limit;
    public $offset;

    function __construct(Nette\Database\Context $database, DateTime $dateTime, Favorite $fav, Seen $seen, Ad $ad)
    {
        $this->database = $database;
        $this->dateTime = $dateTime;
        $this->fav = $fav;
        $this->seen = $seen;
        $this->ad = $ad;

        $this->orderBy = "ORDER BY ad.created DESC";

        $this->limit;
        $this->offset;
    }

    /**
     * @return mixed
     */
    public function getMake()
    {
        return $this->make;
    }

    /**
     * @param mixed $make
     */
    public function setMake($make)
    {
        if ($make != null) $this->make = "AND ad.make_id = ".$make;
    }

    /**
     * @return mixed
     */
    public function getModel()
    {
        return $this->model;
    }

    /**
     * @param mixed $model
     */
    public function setModel($model)
    {
        if ($model != null) $this->model = "AND ad.model_id = ".$model;
    }

    /**
     * @return mixed
     */
    public function getCategory()
    {
        return $this->category;
    }

    /**
     * @param mixed $category
     */
    public function setCategory($category)
    {
        if ($category != null) $this->category = "AND ad.category_id = ".$category;
    }

    /**
     * @return mixed
     */
    public function getPriceFrom()
    {
        return $this->priceFrom;
    }

    /**
     * @param mixed $priceFrom
     */
    public function setPriceFrom($priceFrom)
    {
        if ($priceFrom != null) $this->priceFrom = "AND ad.price >= ".$priceFrom;
    }

    /**
     * @return mixed
     */
    public function getPriceTo()
    {
        return $this->priceTo;
    }

    /**
     * @param mixed $priceTo
     */
    public function setPriceTo($priceTo)
    {
        if ($priceTo != null) $this->priceTo = "AND ad.price <= ".$priceTo;
    }

    /**
     * @return mixed
     */
    public function getSubcategory()
    {
        return $this->subcategory;
    }

    /**
     * @param mixed $subcategory
     */
    public function setSubcategory($subcategory)
    {
        if ($subcategory != null) $this->subcategory = "AND ad.subcategory_id = ".$subcategory;
    }

    /**
     * @return mixed
     */
    public function getCondition()
    {
        return $this->condition;
    }

    /**
     * @param mixed $condition
     */
    public function setCondition($condition)
    {
        if ($condition != null) $this->condition = "AND ad.condition = '".$condition."'";
    }

    /**
     * @return mixed
     */
    public function getAreaLevel1()
    {
        return $this->area_level_1;
    }

    /**
     * @param mixed $area_level_1
     */
    public function setAreaLevel1($area_level_1)
    {
        if ($area_level_1 != null) $this->area_level_1 = "and ad.area_level_1 IN ('".implode("','",$area_level_1)."')";
    }

    /**
     * @return mixed
     */
    public function getSeller()
    {
        return $this->seller;
    }

    /**
     * @param mixed $seller
     */
    public function setSeller($seller)
    {
        if ($seller != null) $this->seller = "AND ad.user_id = ".$seller;
    }

    /**
     * @return mixed
     */
    public function getUser()
    {
        return $this->user;
    }

    /**
     * @param mixed $user
     */
    public function setUser($user)
    {
        $this->user = $user;
    }

    /**
     * @return mixed
     */
    public function getLimit()
    {
        return $this->limit;
    }

    /**
     * @param mixed $limit
     */
    public function setLimit($limit)
    {
        $this->limit = $limit;
    }

    /**
     * @return mixed
     */
    public function getOffset()
    {
        return $this->offset;
    }

    /**
     * @param mixed $offset
     */
    public function setOffset($offset)
    {
        $this->offset = $offset;
    }



    public function setOrderBy($by, $sort)
    {
        $this->orderBy = "ORDER BY ad.$by $sort";
    }

    /**
     * Return all params
     *
     * @param $id
     * @return FALSE|Nette\Database\Table\ActiveRow
     */
    public function getAds()
    {
        $rows = $this->database->query("SELECT ad.*, user.name AS username, user.email, category.name AS categoryname, make.name AS makename, model.name AS modelname
                                                  FROM ad 
                                                  LEFT JOIN user ON ad.user_id=user.user_id
                                                  LEFT JOIN category ON ad.category_id=category.category_id
                                                  LEFT JOIN make ON ad.make_id=make.make_id 
                                                  LEFT JOIN model ON ad.model_id=model.model_id
                                                  WHERE ad.removed = 0 ".$this->make." ".$this->model." ".$this->priceFrom." ".$this->priceTo." ".$this->area_level_1." ".$this->condition." ".$this->category." ".$this->subcategory." ".$this->seller."                                               
                                                  ".$this->orderBy."
                                                  LIMIT ?
                                                  OFFSET ?
                                                  ", $this->limit, $this->offset);
        $params = array();
        while ($row = $rows->fetch())
        {
            $params[$row['ad_id']]['username'] = $row['username'];
            $params[$row['ad_id']]['email'] = $row['email'];
            $params[$row['ad_id']]['categoryname'] = $row['categoryname'];
            $params[$row['ad_id']]['makename'] = $row['makename'];
            $params[$row['ad_id']]['modelname'] = $row['modelname'];
            $params[$row['ad_id']]['price'] = $row['price'];
            $params[$row['ad_id']]['title'] = $row['title'];
            $params[$row['ad_id']]['text'] = $row['text'];
            $params[$row['ad_id']]['negotiation'] = $row['negotiation'];
            $params[$row['ad_id']]['brand'] = $row['brand'];
            $params[$row['ad_id']]['created'] = $row['created'];
            $params[$row['ad_id']]['condition'] = $row['condition'];
            $params[$row['ad_id']]['area_level_1'] = $row['area_level_1'];
            $params[$row['ad_id']]['imagePath'] = $this->ad->getPathImage($row['ad_id'], 1);
            if ($this->user != null)
            {
                $params[$row['ad_id']]['favorite'] = $this->fav->isSetFavorite($this->user, $row['ad_id']);
                $params[$row['ad_id']]['seen'] = $this->seen->isSeen($this->user, $row['ad_id']);
            }
            else
            {
                $params[$row['ad_id']]['favorite'] = 0;
                $params[$row['ad_id']]['seen'] = 0;
            }

        }
        return $params;
    }

    public function getAdsCount()
    {
        $rows = $this->database->query("SELECT count(*)
                                                  FROM ad 
                                                  LEFT JOIN user ON ad.user_id=user.user_id
                                                  LEFT JOIN category ON ad.category_id=category.category_id
                                                  LEFT JOIN make ON ad.make_id=make.make_id 
                                                  LEFT JOIN model ON ad.model_id=model.model_id
                                                  WHERE ad.removed = 0 ".$this->make." ".$this->model." ".$this->priceFrom." ".$this->priceTo." ".$this->area_level_1." ".$this->condition." ".$this->category." ".$this->subcategory."
                                                  ".$this->orderBy)->fetchField();
        return $rows;
    }

}
