<?php

namespace App\Model;

use Nette;

/**
 * Manage database table
 *
 * @author Monsterboy
 */
class Model extends Base
{
    protected $tableName = 'model';


    /**
     * Return array of models name and id
     *
     * @return array
     */
    public function getModelsByMake($makeId) {

        $rows = $this->findBy(array('make_id'=>$makeId));
        $models = array();
        foreach($rows as $row) {
            $models[$row->model_id] = $row->name;
        }
        return $models;
    }

    public function getModel($id)
    {
        return $this->find($id);
    }

    /**
     * @param $name
     * @param $makeId
     * @return Nette\Database\Table\ActiveRow
     */
    public function addModel($name, $makeId)
    {
        return $this->insert(array("name"=>$name, "make_id"=>$makeId));
    }
}
