<?php

namespace App\Model;

use Nette,
    Nette\Security\Passwords;

/**
 * Manage database table
 *
 * @author Monsterboy
 */
class Search extends Base
{
    protected $tableName = 'search';
    public $database;
    protected $dateTime;
    protected $category;

    function __construct(Nette\Database\Context $database, DateTime $dateTime, Category $category)
    {
        $this->database = $database;
        $this->dateTime = $dateTime;
        $this->category = $category;
    }

    /**
     * Ukládá oblíbené inzeráty
     * 
     * @param array $values Hodnoty z formuláře
     * @return bool
     */
    public function addSearch($valuesDB) {

        $valuesDB['created'] = date('Y-m-d H:i:s');

        $insertedId = $this->insert($valuesDB);
        return $insertedId;
    }

    public function getLastSearch($userId,$limit)
    {
        $rows = $this->database->query("SELECT search.*, category.name AS categoryName, make.name AS makeName, model.name AS modelName
                                                  FROM search                                             
                                                  LEFT JOIN category ON search.category_id=category.category_id
                                                  LEFT JOIN make ON search.make_id=make.make_id 
                                                  LEFT JOIN model ON search.model_id=model.model_id
                                                  WHERE search.user_id = $userId
                                                  ORDER BY search.created DESC LIMIT $limit");

        $params = array();
        $i = 0;
        while ($row = $rows->fetch())
        {
            $i++;

            $params[$i]['category_id'] = $row['category_id'];
            $params[$i]['subcategory_id'] = $row['subcategory_id'];
            $params[$i]['make_id'] = $row['make_id'];
            $params[$i]['model_id'] = $row['model_id'];

            $params[$i]['categoryName'] = $row['categoryName'];
            if ($row['subcategory_id'] > 0)
            {
                $subCat = $this->category->getCategory($row['subcategory_id']);
                $params[$i]['subcategoryName'] = $subCat['name'];
            }
            $params[$i]['makeName'] = $row['makeName'];
            $params[$i]['modelName'] = $row['modelName'];
            $params[$i]['price_from'] = $row['price_from'];
            $params[$i]['price_to'] = $row['price_to'];
            $params[$i]['condition'] = $row['condition'];

        }
        return $params;
    }

    /**
     * @param $userId
     * @return array
     */
    public function getAll($userId)
    {
        $results = array();
        $rows = $this->findBy(array("user_id" => $userId));
        while ($row = $rows->fetch())
        {
            $results[] = $row['ad_id'];
        }
        return $results;
    }
}
