<?php

namespace App\Presenters;

use Nette,
	App\Model;
use Nette\Application\UI\Form;

/**
 * Inzerat presenter.
 */
class InzeratPresenter extends BasePresenter
{
    public $adId;
    private $ad;

    public function beforeRender()
    {
        parent::beforeRender();

        if ($this->getUser()->getIdentity())
        {
            $userData = $this->getUser()->getIdentity()->getData();
            if (isset($userData['user_id'])) $this->template->userId = $userData['user_id'];
            else $this->template->userId = null;
        }
    }

	public function renderDefault($id)
	{
        if($this->user->loggedIn)
        {
            $userData = $this->getUser()->getIdentity()->getData();
            $this->context->seen->addSeen($userData['user_id'], $id);
        }

	    $this->adId = $id;

        $this->template->ad = $ad =$this->ad = $this->context->ad->getAd($this->adId);
        $this->template->category = $this->context->category->getCategory($ad->category_id);
        $this->template->subcategory = $this->context->category->getCategory($ad->subcategory_id);
        $this->template->make = $this->context->make->getMake($ad->make_id);
        $this->template->model = $this->context->model->getModel($ad->model_id);
        $this->template->rating = $this->context->ratings->getRating($this->ad['user_id']);
        $this->template->owner = $this->context->users->getProfileParams($this->ad['user_id']);
        $this->template->images = $this->context->ad->getImages($this->adId);
        $this->template->similars = $this->context->ad->getSimilarAds($this->ad['category_id'], $this->ad['make_id'], $this->ad['model_id'], 4);
	}

    /**
     * Set favorite ad
     *
     * @throws Nette\Application\AbortException
     */
    public function handleAddFavorite()
    {
        if($this->user->loggedIn)
        {
            $userData = $this->getUser()->getIdentity()->getData();
            $this->context->favorite->addFavorite($userData['user_id'], $_REQUEST['ad']);
            $success = array('success'=>'Uloženo');
            $this->sendResponse(new Nette\Application\Responses\JsonResponse($success));
        }
        else
        {
            $loginWarning = array('error'=>'Pro uložení do oblíbených se musíte přihlásit');
            $this->sendResponse(new Nette\Application\Responses\JsonResponse($loginWarning));
        }
    }
}
