<?php

namespace App\Model;

use Nette;

/**
 * Manage database table services
 *
 * @author Monsterboy
 */
class Category extends Base
{
    protected $tableName = 'category';

    /**
     * @param $id
     * @return FALSE|Nette\Database\Table\ActiveRow
     */
    public function getCategory($id)
    {
        return $this->find($id);
    }

    /**
     * Return array of services name and id
     *
     * @return array
     */
    public function getCategories() {

        $rows = $this->findBy(array('parent_category_id'=>0));
        $categories = array();
        foreach($rows as $row) {
            $categories[$row->category_id] = $row->name;
        }
        return $categories;
    }

    /**
     * Return array of services name and id
     *
     * @return array
     */
    public function getSubCategories($categoryId) {

        $rows = $this->findBy(array('parent_category_id'=>$categoryId));
        $categories = array();
        foreach($rows as $row) {
            $categories[$row->category_id] = $row->name;
        }
        return $categories;
    }

    /**
     * Return array of categories and services
     *
     * @return mixed
     */
    public function getAllCategories()
    {

        $result = array();
        $rows = $this->getCategories();
        foreach ($rows as $row)
        {
            $result[$row['name']] = $this->getSubCategories($row['category_id']);
        }
        return $result;
    }
}
