<?php

namespace App\Model;

use Nette;

/**
 * Manage database table services
 *
 * @author Monsterboy
 */
class Ratings extends Base
{
    protected $tableName = 'ratings';

    public function setRating($sellerId, $userId, $rating, $comment)
    {
        $this->tableName = 'ratings';

        $values = array();
        $values['rating'] = $rating;
        $values['comment'] = $comment;
        $values['seller_id'] = $sellerId;
        $values['user_id'] = $userId;
        $values['created'] = date('Y-m-d H:i:s');

        if ($this->countBy(array('user_id' => $userId, 'seller_id' => $sellerId)) > 0)
        {
            //$data = $this->findOneBy(array('user_id' => $userId, 'seller_id' => $sellerId));
            $this->update(array('user_id' => $userId, 'seller_id' => $sellerId), $values);
        }
        else
        {
            $this->insert($values);
        }
    }

    public function getRating($sellerId, $round = 0)
    {
        $rating = $this->database->query("SELECT AVG(rating) FROM ratings WHERE seller_id = $sellerId")->fetch();
        $rating = round($rating[0], $round);
        return $rating;
    }

    public function getAllRatings($sellerId)
    {
        return $this->database->query("SELECT ratings.*, user.name FROM ratings LEFT JOIN user ON ratings.user_id=user.user_id WHERE seller_id = $sellerId  ORDER BY created DESC")->fetchAll();
    }
}
