<?php

namespace App\Model;

use Nette;

/**
 * Manage upload file
 *
 * @author Monsterboy
 */
class Uploader extends Base
{
    protected $tableName = 'housekeepers';

    /**
     * Easy upload file on ftp to target
     *
     * @param $file
     * @param $target
     * @return bool
     */
    public function uploadFileToFTP($file, $target)
    {
        $result = move_uploaded_file($file, $target);
        return $result;
    }

    /**
     * Upload and rename image file to $path
     *
     * @param $file
     * @param $newFileName
     * @param $path
     * @return bool
     */
    public function uploadImage($file, $newFileName, $path)
    {
        $imageFileType = pathinfo($file->name,PATHINFO_EXTENSION);

        if ($imageFileType == "jpg" || $imageFileType == "jpeg")
        {
            $fileType = ".jpg";
        }
        elseif ($imageFileType == "png")
        {
            $fileType = ".png";
        }
        elseif ($imageFileType == "gif")
        {
            $fileType = ".gif";
        }
        else return 'špatný formát obrázku';

        $target = $path.$newFileName.$fileType;

        $this->uploadFileToFTP($file, $target);
    }
}
