<?php

namespace App\Presenters;

use Nette,
	App\Model;
use Nette\Application\UI\Form;
use Nette\Mail\Message;
use Nette\Mail\SendmailMailer;

/**
 * Homepage presenter.
 */
class ContentPresenter extends BasePresenter
{

	public function renderDefault()
	{
		$this->template->anyVariable = 'any value';
	}

    public function actionStanSeHospodyni()
    {

    }

    public function renderKontakt()
    {

    }

    /**
     * Component of form for sending message
     *
     * @return Form
     */
    protected function createComponentQuestion()
    {
        $form = new Form;
        $form->addText('name')->setRequired('Zadejte prosím vaše jméno.');
        $form->addText('email')->setRequired("Zadejte prosím váš e-mail.")
            ->addRule(Form::EMAIL, 'Zadejte prosím správný formát e-mailu.');
        $form->addTextArea('message')->setRequired('Vyplňtě prosím váš dotaz.');
        $form->addSubmit('submit');

        $form->onSuccess[] = array($this, 'questionSucceeded');
        return $form;
    }

    /**
     * Send e-mail message
     *
     * @param $form
     * @param $values
     */
    public function questionSucceeded($form, $values)
    {
        $mail = new Message;
        $mail->setFrom($values->name.' <'.$values->email.'>')
            ->addTo('adam.korenek@gmail.com')
            ->setSubject('Dotaz - hospodyne.cz')
            ->setBody($values->message);

        $mailer = new SendmailMailer;
        $mailer->send($mail);
    }
}
