<?php

namespace App\Presenters;

use Nette,
	App\Model;
use Nette\Application\UI\Form;


class MessagePresenter extends BasePresenter
{
    public function renderMessage($housekeeper_id, $user_id, $author)
    {
        $userData = $this->getUser()->getIdentity()->getData();

        if (($author == $this->authorMsgHousekeeper) and ($housekeeper_id != $userData['housekeeper_id']))
        {
            $this->template->error = 'Chyba při autorizaci. Zkuste se prosím znovu přihlásit.';
        }
        elseif (($author == $this->authorMsgUser) and ($user_id != $userData['user_id']))
        {
            $this->template->error = 'Chyba při autorizaci. Zkuste se prosím znovu přihlásit.';
        }
        else
        {
            $this->template->housekeeperId = $housekeeper_id;
            $this->template->userId = $user_id;
            $this->template->author = $author;
        }
    }

    /**
     * Handler for sending messages
     */
    public function handleSendMessage()
    {
        if($this->user->loggedIn)
        {
            $userData = $this->getUser()->getIdentity()->getData();
        }
        else
        {
            $loginWarning = array('error'=>'Pro zaslání zprávy se musíte přihlásit');
            $this->sendResponse(new Nette\Application\Responses\JsonResponse($loginWarning));
        }

        if (($_REQUEST['author'] == $this->authorMsgHousekeeper) and ($_REQUEST['housekeeper_id'] != $userData['housekeeper_id']))
        {
            $comunicationWarning = array('error'=>'Je povolena pouze komunikace hospodyně - klient.');
            $this->sendResponse(new Nette\Application\Responses\JsonResponse($comunicationWarning));
        }
        elseif (($_REQUEST['author'] == $this->authorMsgUser) and ($_REQUEST['user_id'] != $userData['user_id']))
        {
            $comunicationWarning = array('error'=>'Je povolena pouze komunikace hospodyně - klient.');
            $this->sendResponse(new Nette\Application\Responses\JsonResponse($comunicationWarning));
        }
        else
        {
            $this->context->messages
                ->sendMessage($_REQUEST['user_id'], $_REQUEST['housekeeper_id'], $_REQUEST['author'], $_REQUEST['text-message']);
            $success = array('success'=>'Odesláno');
            $this->sendResponse(new Nette\Application\Responses\JsonResponse($success));
        }
    }
}
