<?php

namespace App\Presenters;

use Nette,
	App\Model;
use Nette\Application\UI\Form;

/**
 * Homepage presenter.
 */
class PridatInzeratPresenter extends BasePresenter
{
    protected $params;
    private $categories;
    private $subcategories;
    private $make;
    private $model;
    private $area_level_1;
    private $conditions;

    public function beforeRender()
    {
        parent::beforeRender();

        if ($this->getUser()->getIdentity())
        {
            $userData = $this->getUser()->getIdentity()->getData();
            if (isset($userData['user_id'])) $this->template->userId = $userData['user_id'];
            else $this->template->userId = null;
        }
    }

	public function renderDefault()
	{

	}

	protected function createComponentPridat()
	{
        $categories = $this->context->category->getCategories();
        $this->categories = array(""=>"Vyberte kategorii")+$categories;
        $this->subcategories = array("" => "Prvně vyberte Kategorii");

        $makes = $this->context->make->getMakes();
        $this->make = array(""=>"Vyberte značku")+$makes;
        $this->model = array("" => "Prvně vyberte značku");

        $this->area_level_1 = $this->context->filter->getAreaLevel1();
        $this->conditions = $this->context->filter->getCondition();

		$form = new Form;
        $form->addText('title')
            ->setDisabled(!$this->user->loggedIn)
            ->setRequired("Zadejte prosím titulek inzerátu.");
        $form->addText('price')
            ->setDisabled(!$this->user->loggedIn)
            ->setRequired("Zadejte prosím cenu.");
        $form->addCheckbox('negotiation')
            ->setDisabled(!$this->user->loggedIn);
        $form->addText('brand')
            ->setDisabled(!$this->user->loggedIn)
            ->setRequired("Zadejte prosím výrobce dílu.");
        $form->addSelect('condition')->setItems($this->conditions)
            ->setDisabled(!$this->user->loggedIn)
            ->setRequired('Zvolte prosím stav dílu.');
        $form->addSelect('area_level_1')->setItems($this->area_level_1)
            ->setDisabled(!$this->user->loggedIn)
            ->setRequired('Zvolte prosím kraj.');
        $form->addSelect('category_id')->setItems($this->categories)
            ->setDisabled(!$this->user->loggedIn)
            ->setRequired('Zvolte prosím kategorii.');
        $form->addSelect('subcategory_id')->setItems($this->subcategories)
            ->setDisabled(!$this->user->loggedIn)
            ->setRequired('Zvolte prosím podkategorii.');
        $form->addSelect('make_id')->setItems($this->make)
            ->setDisabled(!$this->user->loggedIn);
        $form->addSelect('model_id')
            ->setDisabled(!$this->user->loggedIn);
		$form->addUpload('photo1')
            ->setDisabled(!$this->user->loggedIn)
			->addRule(Form::IMAGE, 'Fotografie musí být JPEG, PNG nebo GIF.')
			->addRule(Form::MAX_FILE_SIZE, 'Maximální velikost souboru je 1 MB.', 1024 * 1024);
        $form->addUpload('photo2')
            ->setDisabled(!$this->user->loggedIn)
            ->addRule(Form::IMAGE, 'Fotografie musí být JPEG, PNG nebo GIF.')
            ->addRule(Form::MAX_FILE_SIZE, 'Maximální velikost souboru je 1 MB.', 1024 * 1024);
        $form->addUpload('photo3')
            ->setDisabled(!$this->user->loggedIn)
            ->addRule(Form::IMAGE, 'Fotografie musí být JPEG, PNG nebo GIF.')
            ->addRule(Form::MAX_FILE_SIZE, 'Maximální velikost souboru je 1 MB.', 1024 * 1024);
        $form->addUpload('photo4')
            ->setDisabled(!$this->user->loggedIn)
            ->addRule(Form::IMAGE, 'Fotografie musí být JPEG, PNG nebo GIF.')
            ->addRule(Form::MAX_FILE_SIZE, 'Maximální velikost souboru je 1 MB.', 1024 * 1024);
        $form->addTextArea('text')
            ->setDisabled(!$this->user->loggedIn);
        $form->addSubmit('submit')
            ->setDisabled(!$this->user->loggedIn);

		$form->onSubmit[] = array($this, 'pridatSucceeded');
		return $form;
	}

	public function pridatSucceeded(Form $form)
	{
        $values = $form->getValues();
        $id = $this->getUser()->getIdentity()->getId();

        $model_id = $form->getHttpData($form::DATA_TEXT, 'model_id');
        $values['model_id'] = $model_id;

        $ad_id = $this->context->ad->addAd($id, $values);

        $path = 'assets/images/ads/'.$ad_id.'/';
        mkdir($path, 0777);
        $stav = $this->context->uploader->uploadImage($values['photo1'], 'ad_img_1', $path);
        unset($values['photo1']);
        $stav = $this->context->uploader->uploadImage($values['photo2'], 'ad_img_2', $path);
        unset($values['photo2']);
        $stav = $this->context->uploader->uploadImage($values['photo3'], 'ad_img_3', $path);
        unset($values['photo3']);
        $stav = $this->context->uploader->uploadImage($values['photo4'], 'ad_img_4', $path);
        unset($values['photo4']);

        $this->redirect('Inzerat:default', $ad_id);
	}


}
