<?php

namespace App\Presenters;

use Nette,
	App\Model;
use Nette\Application\UI\Form;

/**
 * Sign in/out presenters.
 */
class SignPresenter extends BasePresenter
{
    public $agencyEncodeId;
	private $requestPassId;

	/*public function renderRecoveryPass($id)
	{
		echo 'request:'.$id;
		$requestId = $this->context->encodingString->base64url_decode($id);
		echo 'request id:'.$requestId;
		if (!$this->context->newPass->isRequestValid($requestId))
		{
			$this->flashMessage('Platnost odkazu pro obnovu hesla vypršela. Zažádejte prosím znovu o obnovu hesla.','danger');
			$this->redirect('Sign:recovery');
		}
		else
		{
			$this->requestPassId = $requestId;
		}
	}*/

	public function actionRecoveryPass($id)
	{
		$requestId = $this->context->encodingString->base64url_decode($id);
		if (!$this->context->newPass->isRequestValid($requestId))
		{
			$this->flashMessage('Platnost odkazu pro obnovu hesla vypršela. Zažádejte prosím znovu o obnovu hesla.','danger');
			$this->redirect('Sign:recovery');
		}
		else
		{
			$this->requestPassId = $requestId;
		}
	}

	protected function createComponentRecovery()
	{
		$form = new Form;
		$form->addText('email')
			->setRequired("Zadejte prosím váš e-mail.")
			->addRule(Form::EMAIL, 'Zadejte prosím správný formát e-mailu.');
		$form->addSubmit('submit', 'submit');

		$form->onSuccess[] = array($this, 'recoverySucceeded');
		return $form;
	}

	public function recoverySucceeded(Form $form)
	{
		$values = $form->getValues();

		$valArr = array();
		$userId = null;

        $valArr['email'] = $values['email'];
        $countUsers = $this->context->users->countBy($valArr);
        $userId = $this->context->users->getId($values['email']);

		if ($countUsers)
		{
			$requestId = $this->context->newPass->addNewPassRequest($userId);
			$requestCode = $this->context->encodingString->base64url_encode($requestId);

			$this->context->emails->setTemplate("passRecovery.latte");
			$this->context->emails->setRecipient($values['email']);
			$this->context->emails->setSubject("Obnova hesla");
			$params = array(
				"headline" => "Obnova zapomenutého hesla",
				"content" => "Zapomněli jste heslo? To není problém! Stačí kliknout na následující tlačítko nebo zkopírovat a vložit odkaz do prohlížeče. Na webu budete moci zadat a potvrdit své nové heslo. <br> http://sd.najdi-hospodyni.cz/sign/recoverypass/".$requestCode,
				"linkPassRecovery" => "http://sd.najdi-hospodyni.cz/sign/recoverypass/".$requestCode
			);
			$this->context->emails->setParams($params);
			$this->context->emails->sendMail();

			$this->flashMessage('Na Váš e-mail byly zaslány pokyny pro obnovení hesla.','info');
			$this->redirect('Sign:recovery');
		}
		else
		{
			$this->flashMessage('Tento e-mail u nás není registrovaný.','danger');
			$this->redirect('Sign:recovery');
		}

	}

	protected function createComponentRecoveryPass()
	{
		$form = new Form;
		$form->addPassword('password1')
			->setRequired("Zadejte prosím heslo")
			->addRule(Form::MIN_LENGTH, 'Heslo musí mít alespoň %d znaků', 6);
		$form->addPassword('password2')
			->setRequired('Zadejte prosím heslo.')
			->addRule(Form::EQUAL, 'Hesla se neshodují', $form['password1']);
		$form->addSubmit('submit', 'submit');

		$form->onSuccess[] = array($this, 'recoveryPassSucceeded');
		return $form;
	}

	public function recoveryPassSucceeded(Form $form)
	{
		$values = $form->getValues();

		$valArr = array();
		$userId = null;
		$housekeeperId = null;

		$row = $this->context->newPass->getPassRequest($this->requestPassId);

		if ($row['users_id'])
		{
			$valArr['password'] = Nette\Security\Passwords::hash($values['password1']);
			$this->context->users->editUser($row['users_id'], $valArr);
		}
		
		$this->context->newPass->setRequestDone($this->requestPassId);

		$this->flashMessage('Nové heslo bylo úspěšně nastaveno, nyní se můžete přihlásit s novým heslem.','info');
		$this->redirect('Homepage:default');

	}
}
