var placeSearch, autocomplete;
var map;
var markers = [];
var infoWindow;
var locationSelect;
var componentForm = {
  street_number: 'short_name',
  premise: 'short_name',
  route: 'long_name',
  locality: 'long_name',
  administrative_area_level_1: 'short_name',
  administrative_area_level_2: 'short_name',
  neighborhood: 'short_name',
  sublocality_level_1: 'short_name',
  postal_code: 'short_name'
};

function initialize() {
  // Create the autocomplete object, restricting the search
  // to geographical location types.
  autocomplete = new google.maps.places.Autocomplete(
      /** @type {HTMLInputElement} */(document.getElementById('autocompleteAdress')),
      { types: ['geocode'], componentRestrictions: {country: "cz"} });
  // When the user selects an address from the dropdown,
  // populate the address fields in the form.
  google.maps.event.addListener(autocomplete, 'place_changed', function() {
    fillInAddress();
  });
  
    var latDB = document.getElementById("lat").value;
    var lngDB = document.getElementById("lng").value;
    var zoom = document.getElementById("zoom").value;

    if (latDB == "" || lngDB == "") {

        latDB = 50.0755381;
        lngDB = 14.43780049999998;                
    } 
    
    if(zoom == "")
    {
        zoom = 7;
        var latDB2 = 49.7779555;
        var lngDB2 = 15.741413;
    }
    else
    {     
        var latDB2 = latDB;
        var lngDB2 = lngDB;
    }

    var myOptions = {
            zoom: parseInt(zoom),
            draggable: true,
            animation: google.maps.Animation.DROP,
            center: new google.maps.LatLng(latDB2, lngDB2),
            mapTypeId: google.maps.MapTypeId.ROADMAP
    }
    map = new google.maps.Map(document.getElementById("mapa"), myOptions);

    var marker = new google.maps.Marker({
            map: map,
            position: new google.maps.LatLng(latDB, lngDB)
    });
    marker.setMap (map);
    marker.setDraggable (true);

    google.maps.event.addListener(marker, "dragend", function(event) {

        var point = marker.getPosition();
        map.panTo(point);
        document.getElementById("lat").value = point.lat();
        document.getElementById("lng").value  = point.lng();
    });  
    infoWindow = new google.maps.InfoWindow(); 
}

// [START region_fillform]
function fillInAddress() {
  // Get the place details from the autocomplete object.
  var place = autocomplete.getPlace();

  for (var component in componentForm) {
    document.getElementById(component).value = '';
    document.getElementById(component).disabled = false;
  }

  // Get each component of the address from the place details
  // and fill the corresponding field on the form.
  for (var i = 0; i < place.address_components.length; i++) {
    var addressType = place.address_components[i].types[0];
    if (componentForm[addressType]) {
      var val = place.address_components[i][componentForm[addressType]];
      document.getElementById(addressType).value = val;
    }
  }

  document.getElementById("lat").value = place.geometry.location.lat();
  document.getElementById("lng").value  = place.geometry.location.lng();
  showOnMap(place.geometry.location);

}

function showOnMap(geometryLocation)
{
    //Nastavíme vlastnosti šipky
    var myOptions = {
     zoom: 14,
     draggable: true,
     animation: google.maps.Animation.DROP,
     center: geometryLocation,
     mapTypeId: google.maps.MapTypeId.ROADMAP
    }
    map = new google.maps.Map(document.getElementById("mapa"), myOptions);

    var marker = new google.maps.Marker({
        map: map,
        position: geometryLocation
    });
    marker.setMap (map);
    marker.setDraggable (true);

    google.maps.event.addListener(marker, "dragend", function(event) {

    var point = marker.getPosition();
    map.panTo(point);
    document.getElementById("lat").value = point.lat();
    document.getElementById("lng").value  = point.lng();
    });        
}

$(document).ready(function(){
    initialize();
});